import org.jetbrains.kotlin.gradle.tasks.KotlinCompile

plugins {
    kotlin("jvm") version "1.3.40"
    application
}

group = "com.anthonycicchetti.cs5004"
version = "0.1.0"

repositories {
    mavenCentral()
}

dependencies {
    implementation(kotlin("stdlib-jdk8"))

    testCompile("org.junit.jupiter:junit-jupiter-api:5.4.2")
    testRuntime("org.junit.jupiter:junit-jupiter-engine:5.4.2")
}

tasks.withType<KotlinCompile> {
    kotlinOptions.jvmTarget = "1.8"
}

tasks.named<Test>("test") {
    useJUnitPlatform()
}

tasks.register<JavaExec>("Assignment3") {
    classpath = sourceSets.main.get().runtimeClasspath
    main = "com.anthonycicchetti.cs5004.assignment3.Main"
}

tasks.register<JavaExec>("Assignment4") {
    classpath = sourceSets.main.get().runtimeClasspath
    main = "com.anthonycicchetti.cs5004.assignment4.Main"
}

tasks.register<JavaExec>("Assignment5") {
    classpath = sourceSets.main.get().runtimeClasspath
    main = "com.anthonycicchetti.cs5004.assignment5.Main"
}
