package com.anthonycicchetti.cs5004.assignment3.pieces

import com.anthonycicchetti.cs5004.assignment3.Board

sealed class Piece: IChessPiece

data class Bishop(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        TODO()
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}

data class Knight(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}

data class Rook(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        return with(square) {
            this.column == this@Rook.location.column ||
                    this.row == this@Rook.location.row
        }
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}

data class Queen(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}

data class King(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}

data class Pawn(var location: Board.BoardLocation, private val color: Color): Piece() {
    override fun moveTo(square: Board.BoardLocation): Boolean {
        if (canMoveTo(location)) {
            this.location = square
            return true
        }
        return false
    }

    override fun getPosition(): Board.BoardLocation {
        return location
    }

    override fun getColor(): Color {
        return color
    }

    override fun canMoveTo(square: Board.BoardLocation): Boolean {
        TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
    }

    override fun canKill(enemyPiece: IChessPiece): Boolean {
        return canMoveTo(enemyPiece.getPosition())
    }
}