package com.anthonycicchetti.cs5004.assignment5

import java.nio.CharBuffer

class MarbleSolitaireControllerImpl(private val rd: Readable, private val ap: Appendable)
    : MarbleSolitaireController {

    private fun printGameStateToAppendable(model: MarbleSolitaireModel) {
        ap.appendln(model.getGameState())
        ap.appendln("Score: ${model.getScore()}")
    }

    override fun playGame(model: MarbleSolitaireModel) {
        var cb = CharBuffer.allocate(100)

        printGameStateToAppendable(model)

        ap.appendln("Waiting for move:")
        rd.read(cb)

        while (!(cb.array().filter { it != '\u0000' }.size == 2 && (cb.array()[0] == 'q' || cb.array()[0] == 'Q' ) )){

            val input = cb.array().filter { it != '\u0000' }

            val filteredInput = input.filter { !it.isWhitespace() }

            if (filteredInput.size != 4) {
                ap.appendln("Invalid input. Try again.")
            }

            val (fromRow, fromCol, toRow, toCol) = filteredInput.map { it.toInt() - 49 }

            model.move(fromRow, fromCol, toRow, toCol)

            printGameStateToAppendable(model)

            ap.appendln("Waiting for next move:")
            // clears out the buffer to prepare for the next event
            cb = CharBuffer.allocate(100)
            rd.read(cb)
        }

        with (ap) {
            appendln("Game quit!")
            appendln("State of game when quit:\n ${model.getGameState()}")
            appendln("Score: ${model.getScore()}")
        }

    }
}