package com.anthonycicchetti.cs5004.assignment3.pieces

import com.anthonycicchetti.cs5004.assignment3.Board
import org.junit.jupiter.api.Test

import org.junit.jupiter.api.Assertions.*

internal class BishopTest {

    val A_ONE = Board.BoardLocation(Board.Column.A, Board.Row.ONE)
    val D_FOUR = Board.BoardLocation(Board.Column.D, Board.Row.FOUR)

    @Test
    fun getPosition() {
        val expected = Bishop(A_ONE, Color.WHITE)
        val actual = Bishop(Board.BoardLocation(Board.Column.A, Board.Row.ONE), Color.WHITE)
        assertEquals(expected, actual)
    }

    @Test
    fun `Can Move One Space Up-Right`() {
        val bishop = Bishop(A_ONE, Color.WHITE)
        assertTrue(bishop.canMoveTo(Board.BoardLocation(Board.Column.B, Board.Row.TWO)))
    }

    @Test
    fun `Can Move Four Spaces Up-Right`() {
        val bishop = Bishop(A_ONE, Color.WHITE)
        assertTrue(bishop.canMoveTo(Board.BoardLocation(Board.Column.D, Board.Row.FOUR)))
    }

    @Test
    fun `Cannot Move One Space Right`() {
        val bishop = Bishop(A_ONE, Color.WHITE)
        assertFalse(bishop.canMoveTo(Board.BoardLocation(Board.Column.B, Board.Row.ONE)))
    }
}
