package com.anthonycicchetti.cs5004.assignment3.pieces

import com.anthonycicchetti.cs5004.assignment3.Board
import org.junit.jupiter.api.Test

import org.junit.jupiter.api.Assertions.*

internal class RookTest {

    val A_ONE = Board.BoardLocation(Board.Column.A, Board.Row.ONE)
    val D_FOUR = Board.BoardLocation(Board.Column.D, Board.Row.FOUR)

    @Test
    fun `Can Move One Space to the Right`() {
        val rook = Rook(A_ONE, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.B, Board.Row.ONE)))
    }

    @Test
    fun `Can Move Four Spaces to the Right`() {
        val rook = Rook(A_ONE, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.E, Board.Row.ONE)))
    }

    @Test
    fun `Can Move One Space to the Left`() {
        val rook = Rook(D_FOUR, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.C, Board.Row.FOUR)))
    }

    @Test
    fun `Can Move Three Spaces to the Left`() {
        val rook = Rook(D_FOUR, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.A, Board.Row.FOUR)))
    }

    @Test
    fun `Can Move One Space Up`() {
        val rook = Rook(A_ONE, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.A, Board.Row.TWO)))
    }

    @Test
    fun `Can Move Five Spaces Up`() {
        val rook = Rook(A_ONE, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.A, Board.Row.FIVE)))
    }

    @Test
    fun `Can Move One Space Down`() {
        val rook = Rook(D_FOUR, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.D, Board.Row.THREE)))
    }

    @Test
    fun `Can Move Two Spaces Down`() {
        val rook = Rook(D_FOUR, Color.WHITE)

        assertTrue(rook.canMoveTo(Board.BoardLocation(Board.Column.D, Board.Row.TWO)))
    }
}